#include <windows.h>
#include <math.h>
#include "resource.h"
#include "showrov.h"

extern BOOL CALLBACK DialogConfRov(HWND hDlgConfRov, UINT message, WPARAM wParam, LPARAM lParam) ;
extern BOOL CALLBACK DialogCamera(HWND hDlgCamera, UINT message, WPARAM wParam, LPARAM lParam) ;
extern BOOL CALLBACK DialogMvt(HWND hDlgMvt, UINT message, WPARAM wParam, LPARAM lParam) ;
extern BOOL CALLBACK DialogPil(HWND hDlgPil, UINT message, WPARAM wParam, LPARAM lParam) ;
extern HWND hDlgConfRov, hDlgCamera, hDlgMvt, hDlgPil; // hwnd de la bote de dialogue

#define GLOBAL

#define SIZEMETA 2000
GLOBAL int Sizemeta = SIZEMETA;
GLOBAL double sizemeta = SIZEMETA*1., szms2 = SIZEMETA/2.;
GLOBAL HENHMETAFILE	hemf;
GLOBAL RECT RectMeta ;
extern HDC hdc_cou;

extern double conf_cam[10] ;
extern double xyzltr[10] ;

static char szPpaleName[] = "MonAppli" ;	// Nom de classe de la fentre Ppale
static HWND	hwndPpale ;

void avance(double dist, double courbure);
extern double Vitavant, Courbure, courb_max, vit_max;
extern int fMarche;

#pragma comment (lib, "ddraw.lib") 
#include <windowsx.h>
#include <ddraw.h>
/*--------------------------------------------------------------------------*/
/*   CREATION OBJET DIRECT-DRAW + SURFACE PRIMAIRE + CLIPPING               */
/*--------------------------------------------------------------------------*/
/*   Entres :																*/
/*		hwnd	 : Handle sur la fenetre									*/
/*		makeclip : TRUE si clipping dsir									*/
/*   Sortie :																*/
/*		ppDD	 : pointeur2 sur l'objet DirectDraw cr					*/
/*   Renvoi :																*/
/*      lpDDSPrimary : pointeur sur la surface primaire cre                */
/*      NULL		 : si echec                                             */
/*--------------------------------------------------------------------------*/
LPDIRECTDRAWSURFACE MakePrimSurf(LPDIRECTDRAW *ppDD, HWND hwnd, int makeclip)
{
LPDIRECTDRAW		lpDD;
DDSURFACEDESC		ddsd;
LPDIRECTDRAWSURFACE lpDDSPrimary;
static LPDIRECTDRAWCLIPPER lpClipper;

    // Creation objet DD en mode fenetre standart 
    if (DirectDrawCreate(NULL, &lpDD, NULL) != DD_OK) return NULL;
    if (IDirectDraw_SetCooperativeLevel(lpDD, hwnd, DDSCL_NORMAL) != DD_OK) return NULL;

	// Creation de la surface primaire
    ddsd.dwSize = sizeof(ddsd);  
	ddsd.dwFlags = DDSD_CAPS;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
    if (IDirectDraw_CreateSurface(lpDD, &ddsd, &lpDDSPrimary, NULL) != DD_OK) return NULL;

	if (makeclip)
	{
		// Creation de son clipping
		if (IDirectDraw_CreateClipper(lpDD, 0, &lpClipper, NULL) != DD_OK) return NULL;
		if (IDirectDrawClipper_SetHWnd(lpClipper, 0, hwnd) != DD_OK) return NULL;
		if (IDirectDrawSurface_SetClipper(lpDDSPrimary, lpClipper) != DD_OK) return NULL;
	}

	*ppDD = lpDD;
	return lpDDSPrimary;
}

/*--------------------------------------------------------------------------*/
/*   CREATION SURFACE SECONDAIRE                                            */
/*   Renvoi NULL si echec                                                   */
/*--------------------------------------------------------------------------*/
LPDIRECTDRAWSURFACE MakeOtherSurf(LPDIRECTDRAW pdd, int largeur, int hauteur)
{
DDSURFACEDESC       ddsd;
LPDIRECTDRAWSURFACE pdds;

    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = largeur;
    ddsd.dwHeight = hauteur;
    if (IDirectDraw_CreateSurface(pdd, &ddsd, &pdds, NULL) != DD_OK) return NULL;
    return pdds;
}

LPDIRECTDRAW		lpDD;			// DirectDraw object
LPDIRECTDRAWSURFACE	lpDDSPrimary;	// DirectDraw primary surface
LPDIRECTDRAWSURFACE	lpDDSOne;		// Offscreen surface 1

/*
 * finiObjects
 *
 * finished with all objects we use; release them
 */
static void finiObjects( void )
{
    if( lpDD != NULL )
    {
		if( lpDDSPrimary != NULL )
		{
			IDirectDrawSurface_Release(lpDDSPrimary);
			lpDDSPrimary = NULL;
		}
		if( lpDDSOne != NULL )
		{
			IDirectDrawSurface_Release(lpDDSOne);
			lpDDSOne = NULL;
		}
		IDirectDraw_Release(lpDD);
		lpDD = NULL;
    }
} /* finiObjects */


BOOL initFail(HWND hwnd)
{
    MessageBox(hwnd, "Echec Initialisation DirectDraw", "", MB_OK);
    finiObjects();
    DestroyWindow(hwnd);
    return FALSE;

}

void MyMessBox(char *pt)
{ MessageBox(hwndPpale, pt, "", 0); }

//---------------------------------------------
// Procdure d'enregistrement de classe fentre
//---------------------------------------------
ATOM EnregWindow (WNDPROC WndProc, LPCTSTR szAppName, HANDLE  hInstance, HICON hicon, LPCTSTR szMenuName)
{
WNDCLASSEX    wndclass ;


	wndclass.cbSize        = sizeof (wndclass) ;
	wndclass.style         = CS_HREDRAW | CS_VREDRAW ; // redessiner si modif taille
	wndclass.lpfnWndProc   = WndProc ;
	wndclass.cbClsExtra    = 0 ;
	wndclass.cbWndExtra    = 0 ;
	wndclass.hInstance     = hInstance ; // de la ppale
	wndclass.hIcon         = hicon ;
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
	wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
	wndclass.lpszMenuName  = szMenuName ;
	wndclass.lpszClassName = szAppName ;
	wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION) ;
	return RegisterClassEx(&wndclass); // 0 si chec
}


void UpdateDraw(void)
{
RECT			destRect, oriRect, rect;
HRESULT			ddrval;
POINT           pt;
HDC hdc;
static int tc, lasttc = 0;
int x, y;

#if 0
    tc = GetTickCount();
    if((tc - lasttc) <= 10) return;
    lasttc = tc;
#endif

	if(IDirectDrawSurface_GetDC(lpDDSOne, &hdc) != DD_OK) 
	{
		MessageBox(NULL,"echec acces hdc Surface DDX","",0);
		return ;
	}
	if (hemf)
	{
		PatBlt(hdc,0,0,Sizemeta,Sizemeta,WHITENESS);
		GetClientRect(hwndPpale, &oriRect);
		x = oriRect.right; 
		y = oriRect.bottom;
		if(x>y) SetRect(&rect,0,(y-x)/2, x, (y+x)/2);
		else	SetRect(&rect,(x-y)/2,0, (y+x)/2, y);
		PlayEnhMetaFile(hdc, hemf, &rect);
		IDirectDrawSurface_ReleaseDC(lpDDSOne, hdc);

		// Transformation rectangle intrieur fenetre en coordonnes cran 
		CopyRect(&destRect, &oriRect);
		pt.x = pt.y = 0; ClientToScreen(hwndPpale, &pt); OffsetRect(&destRect, pt.x, pt.y);
		while(1)
		{
			ddrval = IDirectDrawSurface_Blt(lpDDSPrimary, &destRect, lpDDSOne, &oriRect, 0, NULL);
			if(ddrval == DD_OK) 
				break;
			if(ddrval == DDERR_SURFACELOST) 
				return;
			if( ddrval != DDERR_WASSTILLDRAWING) 
				return;
		}
	}
}

//---------------------------------
// CallBack de la fentre prncipale 
//---------------------------------
LRESULT CALLBACK WndProcPpale (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
static HINSTANCE hInstance ;
HDC			hdc ;
HMENU		hMenu ;

    switch (iMsg)
	{
	case WM_CREATE :
		// On recupere hInstance pour les boites de dialogue
		hInstance = ((LPCREATESTRUCT) lParam)->hInstance ;

#ifdef MENU_SYSTEME
		// On ajoute au menu systme aprs un sparateur
		hMenu = GetSystemMenu(hwnd, FALSE);
		AppendMenu(hMenu,MF_SEPARATOR,0,NULL);
#else
		hMenu = CreateMenu() ;
#endif
		AppendMenu(hMenu,0,1,"Test articulations");		
		AppendMenu(hMenu,0,2,"Point de vue");
		AppendMenu(hMenu,0,3,"Placement");
		AppendMenu(hMenu,0,4,"Mini-Pilote");
#ifndef MENU_SYSTEME
		SetMenu(hwnd,hMenu);
#endif

		hdc = GetDC(hwnd);
		SetRect (&RectMeta, 0, 0, // dim meta en 1/100 de mm
			(int) (sizemeta*100.*GetDeviceCaps(hdc,HORZSIZE)/GetDeviceCaps(hdc,HORZRES)),
			(int) (sizemeta*100.*GetDeviceCaps(hdc,VERTSIZE)/GetDeviceCaps(hdc,VERTRES))) ;
		ReleaseDC(hwnd,hdc);
		hemf = NULL;

		return 0 ; 

	case WM_DESTROY : // Il faut dtruire la fentre
		if (hdc_cou != NULL)
		{
			hemf = CloseEnhMetaFile(hdc_cou);
			hdc_cou = NULL;
		}

		if (hemf != NULL) 
		{
			DeleteEnhMetaFile (hemf) ; 
			hemf = NULL;
		}

		fin_showrov();			

        finiObjects();

		PostQuitMessage (0) ; // On envoie le WM_QUIT
		return 0 ;
//#define MODALE_cad_BLOQUE
//#define TJ_EN_AVANT

#ifdef MENU_SYSTEME
	case WM_SYSCOMMAND :
#else
	case WM_COMMAND :
#endif
		switch(wParam)
		{
		case 1:
			// On cree la boite de dialogue de modif configuration
#ifdef MODALE_cad_BLOQUE
#	ifdef TJ_EN_AVANT
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogConfRov) ;
#	else // peut passer en arrire
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG1), (HWND) NULL, DialogConfRov) ;
#	endif
#else    // cad non modale
			if (hDlgConfRov == NULL) /* sinon elle existe dja */
#	ifdef TJ_EN_AVANT
				hDlgConfRov = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, (DLGPROC)DialogConfRov) ;
#	else // peut passer en arrire
				hDlgConfRov = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), (HWND) NULL, (DLGPROC)DialogConfRov) ;
#	endif
			ShowWindow (hDlgConfRov, SW_SHOW) ;
			BringWindowToTop(hDlgConfRov) ;
#endif
			return 0 ; 
		case 2 :
#ifdef MODALE_cad_BLOQUE
#	ifdef TJ_EN_AVANT
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG2), hwnd, DialogCamera) ;
#	else // peut passer en arrire
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG2), (HWND) NULL, DialogCamera) ;
#	endif
#else    // cad non modale
			if (hDlgCamera == NULL) /* sinon elle existe dja */
#	ifdef TJ_EN_AVANT
				hDlgCamera = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG2), hwnd, (DLGPROC)DialogCamera) ;
#	else // peut passer en arrire
				hDlgCamera = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG2), (HWND) NULL, (DLGPROC)DialogCamera) ;
#	endif
			ShowWindow (hDlgCamera, SW_SHOW) ;
			BringWindowToTop(hDlgCamera) ;
#endif
			return 0;
		case 3 :
#ifdef MODALE_cad_BLOQUE
#	ifdef TJ_EN_AVANT
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG3), hwnd, DialogMvt) ;
#	else // peut passer en arrire
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG3), (HWND) NULL, DialogMvt) ;
#	endif
#else    // cad non modale
			if (hDlgMvt == NULL) /* sinon elle existe dja */
#	ifdef TJ_EN_AVANT
				hDlgMvt = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG3), hwnd, (DLGPROC)DialogMvt) ;
#	else // peut passer en arrire
				hDlgMvt = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG3), (HWND) NULL, (DLGPROC)DialogMvt) ;
#	endif
			ShowWindow (hDlgMvt, SW_SHOW) ;
			BringWindowToTop(hDlgMvt) ;
#endif
			return 0;

		case 4 :
#ifdef MODALE_cad_BLOQUE
#	ifdef TJ_EN_AVANT
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG4), hwnd, DialogPil) ;
#	else // peut passer en arrire
			DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG4), (HWND) NULL, DialogPil) ;
#	endif
#else    // cad non modale
			if (hDlgPil == NULL) /* sinon elle existe dja */
#	ifdef TJ_EN_AVANT
				hDlgPil = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG4), hwnd, (DLGPROC)DialogPil) ;
#	else // peut passer en arrire
				hDlgPil = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG4), (HWND) NULL, (DLGPROC)DialogPil) ;
#	endif
			ShowWindow (hDlgPil, SW_SHOW) ;
			BringWindowToTop(hDlgPil) ;
#endif
			return 0;
		default :
		break ;
		}

	case WM_CHAR :
		switch(wParam)
		{
		case 'x' :
			xyzltr[0] += 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case 'X' :
			xyzltr[0] -= 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case 'y' :
			xyzltr[1] += 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case 'Y' :
			xyzltr[1] -= 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case 'c' :
			xyzltr[3] += 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case 'C' :
			xyzltr[3] -= 0.05;
			UpdateRov(0, 0, 1);
			return 0;
		case '*' :
			conf_cam[8] *= 1.02;
			UpdateRov(0, 1, 0);
			return 0;
		case '/' :
			conf_cam[8] /= 1.02;
			UpdateRov(0, 1, 0);
			return 0;
		case '+' :
			if (Vitavant == 0.) { fMarche = 1; Vitavant = 0.01;}
			else
			{
				Vitavant *= 1.5;
				if (fabs(Vitavant) > vit_max) Vitavant *= vit_max/fabs(Vitavant);
			}
			avance(Vitavant, Courbure);
			UpdateRov(0,0,0);
			return 0;
		case '-' :
			if (Vitavant == 0.) { fMarche = -1; Vitavant = -0.01;}
			else if (fabs(Vitavant) > 0.01) Vitavant /= 1.5;
			else { fMarche = 0; Vitavant = 0.;}
			return 0;
		case 's' :
		case 'S' :
			fMarche = 0;
			return 0;
		case 'a' :
		case 'A' :
			fMarche = 1;
			Vitavant = fabs(Vitavant);
			avance(Vitavant, Courbure);
			UpdateRov(0,0,0);
			return 0;
		case 'r' :
		case 'R' :
			fMarche = -1;
			Vitavant = -fabs(Vitavant);
			avance(Vitavant, Courbure);
			UpdateRov(0,0,0);
			return 0;
		}
		break;

	case WM_KEYDOWN :
		switch(wParam)
		{
		case VK_LEFT :
			Courbure = courb_max + 0.9*(Courbure - courb_max);
			avance(Vitavant, Courbure);
			UpdateRov(0,0,0);
			return 0;
		case VK_RIGHT :
			Courbure = -courb_max + 0.9*(Courbure + courb_max);
			avance(Vitavant, Courbure);
			UpdateRov(0,0,0);
			return 0;
		case VK_UP :
			conf_cam[1] -= 0.02;
			UpdateRov(0, 1, 0);
			return 0;
		case VK_DOWN :
			conf_cam[1] += 0.02;
			UpdateRov(0, 1, 0);
			return 0;
		case VK_HOME :
			conf_cam[0] -= 0.02; 
			UpdateRov(0, 1, 0);
			return 0;
		case VK_END :
			conf_cam[0] += 0.02;
			UpdateRov(0, 1, 0);
			return 0;
		case VK_PRIOR :
			conf_cam[1] -= 0.02;
			UpdateRov(0, 1, 0);
			return 0;
		case VK_NEXT :
			conf_cam[1] += 0.02;
			UpdateRov(0, 1, 0);
			return 0;
		}
		break;
	}

	// Traitemement par dfaut des messages non traits prcdemment
	return DefWindowProc (hwnd, iMsg, wParam, lParam) ; 
}


int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
char szPpaleName[] = "ClassPpale" ;	// Nom de classe de la fentre Ppale
MSG		msg ;

	if (hInstance == hPrevInstance) return 1 ; // On limite le nombre d'instance  1 (pour voir)
	if (!EnregWindow (WndProcPpale, szPpaleName, hInstance, LoadIcon (NULL, IDI_APPLICATION), NULL))
		return 1 ; // Echec enregitrement fentre principale


	hwndPpale = CreateWindow (szPpaleName, "Simulation VAP", WS_OVERLAPPEDWINDOW,
                    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                    NULL, NULL, hInstance, NULL) ;



	ShowWindow (hwndPpale, iCmdShow) ; 
	UpdateWindow (hwndPpale) ;

	// CREATION SURFACE PRIMAIRE
	if((lpDDSPrimary = MakePrimSurf(&lpDD, hwndPpale, 1)) == NULL) return initFail(hwndPpale);

	// CREATION SURFACE SECONDAIRE
	if ((lpDDSOne = MakeOtherSurf(lpDD, Sizemeta, Sizemeta))==NULL) return initFail(hwndPpale);


	// On initialise les calculs du rover
	init_showrov () ;


	while (TRUE)
	{
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if(msg.message == WM_QUIT) break ;
			{
				TranslateMessage (&msg) ;	
				DispatchMessage (&msg) ;
			}
		}
		else
		{
			if (fMarche)	
			{
				avance(Vitavant, Courbure);
				UpdateRov(0,0,0);
			}
			UpdateDraw();
		}
	}
	return msg.wParam ;
}
